Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSubPixelPositionEdgels Class Reference

`#include <vtkSubPixelPositionEdgels.h>`

Inheritance diagram for vtkSubPixelPositionEdgels:

[legend]
Collaboration diagram for vtkSubPixelPositionEdgels:

[legend]
List of all members.

## Detailed Description

adjust edgel locations based on gradients.

Date:
  2002/11/03 22:51:56

Revision:
  1.34

vtkSubPixelPositionEdgels is a filter that takes a series of linked edgels (digital curves) and gradient maps as input. It then adjusts the edgel locations based on the gradient data. Specifically, the algorithm first determines the neighboring gradient magnitudes of an edgel using simple interpolation of its neighbors. It then fits the following three data points: negative gradient direction gradient magnitude, edgel gradient magnitude and positive gradient direction gradient magnitude to a quadratic function. It then solves this quadratic to find the maximum gradient location along the gradient orientation. It then modifies the edgels location along the gradient orientation to the calculated maximum location. This algorithm does not adjust an edgel in the direction orthogonal to its gradient vector.

See also:
  vtkImage vtkImageGradient vtkLinkEdgels

Created by:
  - Martin, Ken

CVS contributions (if > 5%):
  - Martin, Ken (66%)
  - Avila, Lisa (6%)
  - Geveci, Berk (5%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkSubPixelPositionEdgels.h)`
  - .`cxx` (`/Graphics/vtkSubPixelPositionEdgels.cxx)`

Tests:
  vtkSubPixelPositionEdgels (Tests)

Definition at line 63 of file vtkSubPixelPositionEdgels.h.

## Public Types
typedef vtkPolyDataToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetGradMaps (vtkStructuredPoints *gm)
vtkStructuredPoints * | GetGradMaps ()
virtual void | SetTargetFlag (int)
virtual int | GetTargetFlag ()
virtual void | TargetFlagOn ()
virtual void | TargetFlagOff ()
virtual void | SetTargetValue (float)
virtual float | GetTargetValue ()
## Static Public Methods
vtkSubPixelPositionEdgels * | New ()
int | IsTypeOf (const char *type)
vtkSubPixelPositionEdgels * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkSubPixelPositionEdgels ()
| ~vtkSubPixelPositionEdgels ()
void | Execute ()
void | Move (int xdim, int ydim, int zdim, int x, int y, float *img, vtkDataArray *inVecs, float *result, int z, float *aspect, float *resultNormal)
## Protected Attributes
int | TargetFlag
float | TargetValue

## Member Typedef Documentation

typedef vtkPolyDataToPolyDataFilter vtkSubPixelPositionEdgels::Superclass

| Reimplemented from vtkPolyDataToPolyDataFilter. Definition at line 67 of file vtkSubPixelPositionEdgels.h.

## Constructor & Destructor Documentation

vtkSubPixelPositionEdgels::vtkSubPixelPositionEdgels | ( |  | ) | `[protected]`

vtkSubPixelPositionEdgels::~vtkSubPixelPositionEdgels | ( |  | ) | `[protected]`

## Member Function Documentation

vtkSubPixelPositionEdgels* vtkSubPixelPositionEdgels::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkSubPixelPositionEdgels::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

int vtkSubPixelPositionEdgels::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

virtual int vtkSubPixelPositionEdgels::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkSubPixelPositionEdgels* vtkSubPixelPositionEdgels::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

void vtkSubPixelPositionEdgels::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataToPolyDataFilter.

void vtkSubPixelPositionEdgels::SetGradMaps | ( | vtkStructuredPoints * | gm | ) |

| Set/Get the gradient data for doing the position adjustments.

vtkStructuredPoints* vtkSubPixelPositionEdgels::GetGradMaps | ( |  | ) |

| Set/Get the gradient data for doing the position adjustments.

virtual void vtkSubPixelPositionEdgels::SetTargetFlag | ( | int |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

virtual int vtkSubPixelPositionEdgels::GetTargetFlag | ( |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

virtual void vtkSubPixelPositionEdgels::TargetFlagOn | ( |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

virtual void vtkSubPixelPositionEdgels::TargetFlagOff | ( |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

virtual void vtkSubPixelPositionEdgels::SetTargetValue | ( | float |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

virtual float vtkSubPixelPositionEdgels::GetTargetValue | ( |  | ) | `[virtual]`

| These methods can make the positioning look for a target scalar value instead of looking for a maximum.

void vtkSubPixelPositionEdgels::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkSubPixelPositionEdgels::Move | ( | int | xdim,
|  | int | ydim,
|  | int | zdim,
|  | int | x,
|  | int | y,
|  | float * | img,
|  | vtkDataArray * | inVecs,
|  | float * | result,
|  | int | z,
|  | float * | aspect,
|  | float * | resultNormal
| ) | `[protected]`

## Member Data Documentation

int vtkSubPixelPositionEdgels::TargetFlag`[protected]`

| Definition at line 96 of file vtkSubPixelPositionEdgels.h.

float vtkSubPixelPositionEdgels::TargetValue`[protected]`

| Definition at line 97 of file vtkSubPixelPositionEdgels.h.

The documentation for this class was generated from the following file:

- Graphics/vtkSubPixelPositionEdgels.h